define("io.ox/office/spreadsheet/app/application",["io.ox/office/tk/utils","io.ox/office/tk/locale/localedata","io.ox/office/baseframework/utils/errorcode","io.ox/office/baseframework/utils/errorcontext","io.ox/office/editframework/app/editapplication","io.ox/office/spreadsheet/utils/config","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/model","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/view/view","io.ox/office/spreadsheet/app/controller","gettext!io.ox/office/spreadsheet/main"],function(a,b,c,d,e,f,g,h,i,j,k,l){"use strict";function m(a){a.invFunctions=_.invert(a.functions),a.nativeFunctionNames=_.chain(a.functions).keys().sort().value(),a.localizedFunctionNames=_.chain(a.invFunctions).keys().sort().value(),a.invErrorCodes=_.invert(a.errorCodes),a.nativeErrorCodes=_.chain(a.errorCodes).keys().sort().value(),a.localizedErrorCodes=_.chain(a.invErrorCodes).keys().sort().value()}var n=g.RangeArray,o=g.Range3DArray,p={functions:{},errorCodes:_.chain(g.ErrorCodes).map(function(a){return[a.code,a.code]}).object().value(),listSeparator:",",trueLiteral:"TRUE",falseLiteral:"FALSE"},q=/^#[^ !?]+[!?]?$/,r=/^[^-_\s][^-\s]*$/,s={},t={},u=e.extend({constructor:function(u){function v(c){function d(b,d){var e=_.isString(c[b])&&c[b].length>0&&(!d||c[b].length<=d);return e||a.error('  missing or invalid property "'+b+'" in resource data'),e}function e(b){var d=_.isObject(c[b])&&!_.isEmpty(c[b]);return d||a.error('  missing or invalid property "'+b+'" in resource data'),d}var f=G.getFormulaInterpreter().getFunctionDescriptors(),g=[];return a.log("SpreadsheetApplication.preProcessDocument(): locale data response:",c),d("decSeparator",1)&&d("groupSeparator",1)&&d("listSeparator",1)&&d("trueLiteral")&&d("falseLiteral")&&e("functions")&&e("errorCodes")?(I={listSeparator:c.listSeparator,trueLiteral:c.trueLiteral.toUpperCase(),falseLiteral:c.falseLiteral.toUpperCase(),functions:c.functions,errorCodes:c.errorCodes,engineVersion:a.getStringOption(c,"engineVersion","")},_.each(I.functions,function(a,b){b in f||(g.push(b),delete I.functions[b])}),m(I),a.info("SpreadsheetApplication.preProcessDocument(): new locale data:",I),s[L]=I,a.withLogging(function(){b.DEC!==c.decSeparator&&a.error('  decimal separator mismatch: LocaleData.DEC="'+b.DEC+'" response.decSeparator="'+c.decSeparator+'"'),b.GROUP!==c.groupSeparator&&a.error('  group separator mismatch: LocaleData.GROUP="'+b.GROUP+'" response.groupSeparator="'+c.groupSeparator+'"'),I.nativeFunctionNames.length!==I.localizedFunctionNames.length&&a.error("  list of translated function names contains duplicates"),g.length>0&&a.error("  unknown functions in locale data: "+g.sort().join(", "));var d=_.difference(_.keys(f),I.nativeFunctionNames);d.length>0&&a.warn("  missing functions in locale data: "+d.sort().join(", ")),I.nativeErrorCodes.length!==I.localizedErrorCodes.length&&a.error("  list of translated error codes contains duplicates"),_.each(I.nativeErrorCodes,function(b){q.test(b)||a.error('  invalid native error code: "'+b+'"')}),_.each(I.localizedErrorCodes,function(b){q.test(b)||a.error('  invalid translated error code: "'+b+'"')}),I.nativeFunctionNames.forEach(function(b){r.test(b)||a.error('  invalid native function name: "'+b+'"')}),I.localizedFunctionNames.forEach(function(b){r.test(b)||a.error('  invalid localized function name: "'+b+'"')})}),$.when()):$.Deferred().reject()}function w(b){var c=G.getFormulaInterpreter(),d=c.getRawFunctionDescriptors(),e=c.getFunctionDescriptors();K=t[L]={},_.each(b,function(b,c){function f(b,d){a[b]("  "+d+" function "+c)}function g(a){return _.isNumber(a)?a:_.isObject(a)?_.reduce(a,function(a,b){return Math.max(a,b)},0):a}var h=I.invFunctions[c],j=d[h],k=e[h];if(b=_.copy(b,!0),!r.test(c))return f("error","invalid characters in");if(!h)return f("warn","help entry found for unknown");if(!j&&k&&_.isString(k.origName)&&(j=d[k.origName]),!j)return f("warn","help entry found for unimplemented");if(k){if(!_.isObject(b))return f("error","invalid map entry for");_.isString(b.description)?b.description=a.trimString(b.description):(delete b.description,f("error","missing description for")),_.isArray(b.params)?_.all(b.params,_.isString)||f("error","invalid parameter names for"):(f("error","missing parameter names for"),b.params=[]),_.isArray(b.paramshelp)?_.all(b.paramshelp,_.isString)||f("error","invalid parameter descriptions for"):(f("error","missing parameter descriptions for"),b.paramshelp=[]),b.params.length!==b.paramshelp.length&&f("error","count mismatch in parameter names and descriptions for");var l=g(j.minParams);if(b.params.length<l)for(f("error","missing help for required parameters for");b.params.length<l;)b.params.push("");var m=g(j.maxParams);if(_.isNumber(m)&&(b.params.length<m?f("error","missing help for optional parameters for"):m<b.params.length&&f("warn","superfluous optional parameters for")),_.isNumber(k.maxParams)){for(;b.params.length<k.maxParams;)b.params.push("");b.params.splice(k.maxParams)}var n=_.isNumber(k.maxParams)?null:k.repeatParams||1;if(_.isNumber(n)){var o=b.params.length-k.minParams;0!==o&&o!==n&&(f("warn","superfluous variable parameters for"),b.params.splice(k.minParams+(o>n?n:0))),b.repeat=n}b.params=_.map(b.params,function(c,d){var e=b.paramshelp[d];return{name:_.isString(c)?a.trimString(c):"",description:_.isString(e)?a.trimString(e):"",optional:k.minParams<=d}});var p=_.isNumber(b.repeat),q=p?b.params.length-b.repeat:-1;K[h]={name:c,description:b.description,params:b.params,repeatStart:q,cycleLength:p?b.repeat:0,cycleCount:p?Math.floor((i.MAX_PARAM_COUNT-q)/b.repeat):0},_.each(k.altNames,function(a){a in I.functions&&!(a in K)&&(K[a]=_.clone(K[h]),K[a].name=I.functions[a])})}}),a.withLogging(function(){var b=_.difference(_.keys(I.functions),_.keys(K));b.length>0&&a.error("  missing help for functions: "+b.sort().join(", "))})}function x(){var c=null;return L=JSON.stringify({locale:f.LOCALE,format:F.getFileFormat()}),L in t?K=t[L]:$.when(b.loadResource("io.ox/office/spreadsheet/resource/functions"),J).done(w),L in s?(I=s[L],J.resolve(),$.when()):(c=F.sendQueryRequest("localeData",{locale:f.LOCALE}).then(v),c=c.then(null,function(){return a.error('SpreadsheetApplication.preProcessDocument(): could not download locale data for "'+f.LOCALE+'"'),{headline:l("Server Error"),message:l("The engine used for calculating formulas is not available.")}}),c.done(function(){J.resolve()}))}function y(){return 0===G.getSheetCount()?$.Deferred().reject():(G.getCellStyles().createMissingStyles(),$.when())}function z(b){var c=a.getIntegerOption(b,"activeSheet",0);return F.getView().activatePreviewSheet(c)}function A(a){var b=new c(a);switch(b.getCodeAsConstant()){case"LOADDOCUMENT_COMPLEXITY_TOO_HIGH_ERROR":F.setInternalError(b,d.SPREADSHEET,{showMessage:!1});break;case"LOADDOCUMENT_COMPLEXITY_TOO_HIGH_SHEET_COUNT_ERROR":F.setInternalError(b,d.SPREADSHEET,{showMessage:!1})}F.isInQuit()||G.prepareInvalidDocument()}function B(){H.leaveCellEditMode("auto"),H.sendChangedViewAttributes()}function C(){H.leaveCellEditMode("auto")}function D(){H.sendChangedViewAttributes()}function E(b){var c=a.getObjectOption(b,"changed"),d=a.getStringOption(b,"locale"),e=a.getStringOption(c,"error"),g=null,h=null;if(_.isObject(c)){if(a.info("SpreadsheetApplication.updateNotificationHandler(): notification received:",c),c=a.getObjectOption(c,"sheets"),!c)return void a.warn("SpreadsheetApplication.updateNotificationHandler(): no sheets defined");g={},h=new o,_.each(c,function(b,c){var e=parseInt(c,10);if(!isFinite(e)||e<0||e>=G.getSheetCount())return void a.warn('SpreadsheetApplication.updateNotificationHandler(): invalid sheet index: "'+c+'"');if(!_.isObject(b))return void a.warn("SpreadsheetApplication.updateNotificationHandler(): unexpected data for sheet "+e+":",b);var i=new n,j=G.createRangeArray(b.cells)||new n,k=G.createIntervalArray(b.columns,!0),l=G.createIntervalArray(b.rows,!1),m=a.getArrayOption(b,"contents",[]),p=a.getIntegerOption(b,"usedCols"),q=a.getIntegerOption(b,"usedRows"),r={};k&&j.append(k.map(G.makeColRange,G)),l&&j.append(l.map(G.makeRowRange,G)),m=m.filter(function(a){var b=G.createRange(a);if(b)return i.push(b),!0}),m.length>0&&(d===f.LOCALE?(i=i.merge(),j=j.difference(i),r.rangeContents=m,r.contentRanges=i):(j.append(i),i.clear())),j.empty()||(j=j.merge(),r.dirtyRanges=j.clone()),_.isNumber(p)&&(r.usedCols=p),_.isNumber(q)&&(r.usedRows=q),_.isEmpty(r)||(r.sheet=e,g[c]=r),i.empty()||(j=j.append(i).merge()),j.empty()||(r.changedRanges=j,h.append(o.createFromRanges(j,e)))}),_.isEmpty(g)||F.trigger("docs:update:cells",g,h,e)}}var F=this,G=null,H=null,I=_.copy(p,!0),J=$.Deferred(),K={},L=null;e.call(this,h,j,k,u,{newDocumentParams:{initial_sheetname:g.getSheetName(0)},preProcessHandler:x,postProcessHandler:y,previewHandler:z,importFailedHandler:A,prepareFlushHandler:B,prepareLoseEditRightsHandler:C,prepareRenameHandler:D,realTimeDelay:10,supportsOnlineSync:!0}),this.onInitLocale=function(a,b){return J.done(_.bind(a,b)),this},this.getLocalizedFunctionNames=function(){return I.localizedFunctionNames},this.isLocalizedFunctionName=function(a){return a.toUpperCase()in I.invFunctions},this.getLocalizedFunctionName=function(a){return a=a.toUpperCase(),a in I.functions?I.functions[a]:a},this.getNativeFunctionNames=function(){return I.nativeFunctionNames},this.isNativeFunctionName=function(a){return a.toUpperCase()in I.functions},this.getNativeFunctionName=function(a){return a=a.toUpperCase(),a in I.invFunctions?I.invFunctions[a]:a},this.getFunctionHelp=function(a){return a=a.toUpperCase(),a in K&&a in I.functions?K[a]:null},this.getLocalizedErrorCodes=function(){return I.localizedErrorCodes},this.isLocalizedErrorCode=function(a){return a.toUpperCase()in I.invErrorCodes},this.getNativeErrorCodes=function(){return I.nativeErrorCodes},this.isNativeErrorCode=function(a){return a.toUpperCase()in I.errorCodes},this.getListSeparator=function(){return I.listSeparator},this.getBooleanLiteral=function(a){return I[a?"trueLiteral":"falseLiteral"]},this.convertErrorCodeToString=function(a){return a.code in I.errorCodes?I.errorCodes[a.code]:a.code},this.convertStringToErrorCode=function(a){return a=a.toUpperCase(),g.makeErrorCode(a in I.invErrorCodes?I.invErrorCodes[a]:a)},this.getEngineVersion=function(){return I.engineVersion},this.sendQueryRequest=function(a,b,c){return this.sendActionRequest("query",_.extend({},b,{type:a}),c)},this.onInit(function(){G=F.getModel(),H=F.getView(),m(I)}),this.on("docs:update",E),this.registerDestructor(function(){u=F=G=H=I=K=null})}});return u.createLauncher=function(){return e.createLauncher("io.ox/office/spreadsheet",u,{icon:"fa-table",trackingId:"io.ox/spreadsheet-editor"})},u});