define("io.ox/office/spreadsheet/model/formula/impl/complexfuncs",["io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/complex"],function(a,b,c){"use strict";function d(a){return function(){var b=null,d=!1;if(this.iterateOperands(0,function(e){this.iterateValues(e,function(d){var e=this.convertToComplex(d);b?(this.checkComplexUnits(b,e),b=a.call(this,b,e),b.unit=b.unit||e.unit):b=new c(e.real,e.imag,e.unit)},{emptyParam:!1,complexRef:!1}),e.isEmpty()||(d=!0)}),!d)throw e.NA;return _.isObject(b)?b:new c(0,0)}}var e=a.ErrorCodes,f=Math.sin,g=Math.cos,h=b.sinh,i=b.cosh;return{COMPLEX:{category:"complex",minParams:2,maxParams:3,type:"val",signature:"val:num val:num val:str",resolve:function(a,b,d){if(d||(d="i"),"i"!==d&&"j"!==d)throw e.VALUE;return new c(a,b,d)}},IMABS:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return a.abs()}},IMAGINARY:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return a.imag}},IMARGUMENT:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return a.arg()}},IMCONJUGATE:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return new c(a.real,-a.imag,a.unit)}},IMCOS:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return new c(g(a.real)*i(a.imag),-f(a.real)*h(a.imag),a.unit)}},IMCOSH:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return new c(i(a.real)*g(a.imag),h(a.real)*f(a.imag),a.unit)}},IMCOT:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){var b=g(2*a.real)-i(2*a.imag);return new c(-f(2*a.real)/b,h(2*a.imag)/b,a.unit)}},IMCSC:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){var b=g(2*a.real)-i(2*a.imag);return new c(-2*f(a.real)*i(a.imag)/b,2*g(a.real)*h(a.imag)/b,a.unit)}},IMCSCH:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){var b=i(2*a.real)-g(2*a.imag);return new c(2*h(a.real)*g(a.imag)/b,-2*i(a.real)*f(a.imag)/b,a.unit)}},IMDIV:{category:"complex",minParams:2,maxParams:2,type:"val",signature:"val:comp val:comp",resolve:function(a,b){this.checkComplexUnits(a,b);var d=b.real*b.real+b.imag*b.imag;return new c((a.real*b.real+a.imag*b.imag)/d,(a.imag*b.real-a.real*b.imag)/d,a.unit)}},IMEXP:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return a.exp()}},IMLN:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return a.log(1)}},IMLOG10:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return a.log(Math.LN10)}},IMLOG2:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return a.log(Math.LN2)}},IMPOWER:{category:"complex",minParams:2,maxParams:2,type:"val",signature:"val:comp val:num",resolve:function(a,b){return a.pow(b)}},IMPRODUCT:{category:"complex",minParams:1,type:"val",signature:"any",resolve:d(function(a,b){return new c(a.real*b.real-a.imag*b.imag,a.real*b.imag+a.imag*b.real)})},IMREAL:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return a.real}},IMSEC:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){var b=g(2*a.real)+i(2*a.imag);return new c(2*g(a.real)*i(a.imag)/b,2*f(a.real)*h(a.imag)/b,a.unit)}},IMSECH:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){var b=i(2*a.real)+g(2*a.imag);return new c(2*i(a.real)*g(a.imag)/b,-2*h(a.real)*f(a.imag)/b,a.unit)}},IMSIN:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return new c(f(a.real)*i(a.imag),g(a.real)*h(a.imag),a.unit)}},IMSINH:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return new c(h(a.real)*g(a.imag),i(a.real)*f(a.imag),a.unit)}},IMSQRT:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return a.pow(.5)}},IMSUB:{category:"complex",minParams:2,maxParams:2,type:"val",signature:"val:comp val:comp",resolve:function(a,b){return this.checkComplexUnits(a,b),new c(a.real-b.real,a.imag-b.imag,a.unit)}},IMSUM:{category:"complex",minParams:1,type:"val",signature:"any",resolve:d(function(a,b){return new c(a.real+b.real,a.imag+b.imag)})},IMTAN:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){var b=g(2*a.real)+i(2*a.imag);return new c(f(2*a.real)/b,h(2*a.imag)/b,a.unit)}}}});