define("io.ox/office/spreadsheet/model/formula/impl/statisticalfuncs",["io.ox/office/tk/utils","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils"],function(a,b,c){"use strict";function d(a,b){function d(a){return isFinite(a)?a:0}var e="max"===a?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY,f=_.bind(Math[a],Math);return c.implementNumericAggregation(e,f,d,b)}function e(b,d,e){function f(e,f){var g=c.divide(f,e.length),h=a.getSum(e,function(a){var b=a-g;return b*b}),i=d?e.length:e.length-1;return h=c.divide(h,i),"dev"===b?Math.sqrt(h):h}return c.implementNumericAggregationWithArray(f,e)}var f=b.ErrorCodes,g={valMode:"convert",matMode:"skip",refMode:"skip",emptyParam:!0,complexRef:!0},h={valMode:"convert",matMode:"skip",refMode:"zero",emptyParam:!0,complexRef:!0},i={valMode:"convert",matMode:"zero",refMode:"zero",emptyParam:!0,complexRef:!0};return{AVEDEV:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:function(){function b(b,c){if(0===b.length)throw f.NUM;var d=c/b.length;return a.getSum(b,function(a){return Math.abs(a-d)})/b.length}return c.implementNumericAggregationWithArray(b,g)}()},AVERAGE:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:c.implementNumericAggregation(0,c.add,c.divide,g)},AVERAGEA:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:c.implementNumericAggregation(0,c.add,c.divide,i)},AVERAGEIF:{category:"statistical",supported:"ooxml",minParams:2,maxParams:3,type:"val",signature:"ref val:any ref",resolve:c.implementFilterAggregation(0,c.add,c.divide)},AVERAGEIFS:{category:"statistical",supported:"ooxml",minParams:3,repeatParams:2,type:"val",signature:"ref ref val:any"},B:{category:"statistical",supported:"odf",minParams:3,maxParams:4,type:"val"},BETADIST:{category:"statistical",altNames:{ooxml:"BETA.DIST"},minParams:3,maxParams:5,type:"val"},BETAINV:{category:"statistical",altNames:{ooxml:"BETA.INV"},minParams:3,maxParams:5,type:"val"},BINOMDIST:{category:"statistical",altNames:{ooxml:"BINOM.DIST"},minParams:4,maxParams:4,type:"val"},"BINOM.DIST.RANGE":{category:"statistical",supported:"ooxml",minParams:3,maxParams:4,type:"val"},CHIDIST:{category:"statistical",altNames:{ooxml:"CHISQ.DIST.RT"},minParams:2,maxParams:2,type:"val"},CHIINV:{category:"statistical",altNames:{ooxml:"CHISQ.INV.RT"},minParams:2,maxParams:2,type:"val"},CHISQDIST:{category:"statistical",supported:"odf",minParams:2,maxParams:3,type:"val"},"CHISQ.DIST":{category:"statistical",supported:"ooxml",minParams:3,maxParams:3,type:"val"},"CHISQ.DIST.RT":{category:"statistical",supported:"ooxml",minParams:2,maxParams:2,type:"val"},CHISQINV:{category:"statistical",supported:"odf",minParams:2,maxParams:2,type:"val"},"CHISQ.INV":{category:"statistical",supported:"ooxml",minParams:2,maxParams:2,type:"val"},"CHISQ.INV.RT":{category:"statistical",supported:"ooxml",minParams:2,maxParams:2,type:"val"},CHITEST:{category:"statistical",altNames:{ooxml:"CHISQ.TEST"},minParams:2,maxParams:2,type:"val"},CONFIDENCE:{category:"statistical",altNames:{ooxml:"CONFIDENCE.NORM"},minParams:3,maxParams:3,type:"val"},"CONFIDENCE.T":{category:"statistical",supported:"ooxml",minParams:3,maxParams:3,type:"val"},CORREL:{category:"statistical",minParams:2,maxParams:2,type:"val"},COUNT:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:function(){var a=0;return this.iterateOperands(0,function(b){if(b.isValue())try{this.convertToNumber(b.getValue()),a+=1}catch(a){}else this.iterateValues(b,function(b){_.isNumber(b)&&(a+=1)},{acceptErrors:!0,complexRef:!0})}),a}},COUNTA:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:function(){var a=0;return this.iterateOperands(0,function(b){switch(b.getType()){case"val":a+=1;break;case"mat":a+=b.getMatrix().size();break;case"ref":this.iterateValues(b,function(){a+=1},{acceptErrors:!0,complexRef:!0})}}),a}},COUNTBLANK:{category:"statistical",minParams:1,maxParams:1,type:"val",signature:"ref",resolve:function(a){var b=0,c=this.isOOXML();return this.iterateValues(a,function(a){c&&""===a||(b+=1)},{acceptErrors:!0,complexRef:!1}),a.cells()-b}},COUNTIF:{category:"statistical",minParams:2,maxParams:2,type:"val",signature:"ref val:any",resolve:c.implementFilterAggregation(0,_.identity,function(a,b,c){return c})},COUNTIFS:{category:"statistical",supported:"ooxml",minParams:2,repeatParams:2,type:"val"},COVAR:{category:"statistical",altNames:{ooxml:"COVARIANCE.P"},minParams:2,maxParams:2,type:"val"},"COVARIANCE.S":{category:"statistical",supported:"ooxml",minParams:2,maxParams:2,type:"val"},CRITBINOM:{category:"statistical",altNames:{ooxml:"BINOM.INV"},minParams:3,maxParams:3,type:"val"},DEVSQ:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:function(){function b(b,c){if(0===b.length)throw f.NUM;var d=c/b.length;return a.getSum(b,function(a){var b=a-d;return b*b})}return c.implementNumericAggregationWithArray(b,g)}()},EXPONDIST:{category:"statistical",altNames:{ooxml:"EXPON.DIST"},minParams:3,maxParams:3,type:"val"},FDIST:{category:"statistical",altNames:{ooxml:"F.DIST.RT"},minParams:3,maxParams:3,type:"val"},"F.DIST":{category:"statistical",supported:"ooxml",minParams:4,maxParams:4,type:"val"},FINV:{category:"statistical",altNames:{ooxml:"F.INV.RT"},minParams:3,maxParams:3,type:"val"},"F.INV":{category:"statistical",supported:"ooxml",minParams:3,maxParams:3,type:"val"},FISHER:{category:"statistical",minParams:1,maxParams:1,type:"val"},FISHERINV:{category:"statistical",minParams:1,maxParams:1,type:"val"},FORECAST:{category:"statistical",minParams:3,maxParams:3,type:"val"},FREQUENCY:{category:"statistical",minParams:2,maxParams:2,type:"mat"},FTEST:{category:"statistical",altNames:{ooxml:"F.TEST"},minParams:2,maxParams:2,type:"val"},GAMMA:{category:"statistical",minParams:1,maxParams:1,type:"val"},GAMMADIST:{category:"statistical",altNames:{ooxml:"GAMMA.DIST"},minParams:4,maxParams:4,type:"val"},GAMMAINV:{category:"statistical",altNames:{ooxml:"GAMMA.INV"},minParams:3,maxParams:3,type:"val"},GAMMALN:{category:"statistical",minParams:1,maxParams:1,type:"val"},"GAMMALN.PRECISE":{category:"statistical",supported:"ooxml",minParams:1,maxParams:1,type:"val"},GAUSS:{category:"statistical",minParams:1,maxParams:1,type:"val"},GEOMEAN:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:function(){function a(a,b){if(0===a||0===b)throw f.NUM;return Math.pow(a,1/b)}return c.implementNumericAggregation(1,c.multiply,a,g)}()},GROWTH:{category:"statistical",minParams:1,maxParams:4,type:"mat"},HARMEAN:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:function(){function a(a,b){if(0===b)throw f.NUM;return a+1/b}function b(a,b){if(0===b)throw f.NA;return b/a}return c.implementNumericAggregation(0,a,b,g)}()},HYPGEOMDIST:{category:"statistical",altNames:{ooxml:"HYPGEOM.DIST"},minParams:4,maxParams:4,type:"val"},INTERCEPT:{category:"statistical",minParams:2,maxParams:2,type:"val"},KURT:{category:"statistical",minParams:1,type:"val"},LARGE:{category:"statistical",minParams:2,maxParams:2,type:"val"},LINEST:{category:"statistical",minParams:1,maxParams:4,type:"mat"},LOGEST:{category:"statistical",minParams:1,maxParams:4,type:"mat"},LOGINV:{category:"statistical",altNames:{ooxml:"LOGNORM.INV"},minParams:3,maxParams:3,type:"val"},LOGNORMDIST:{category:"statistical",altNames:{ooxml:"LOGNORM.DIST"},minParams:3,maxParams:3,type:"val"},MAX:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:d("max",g)},MAXA:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:d("max",h)},MEDIAN:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:function(){function a(a){var b=a.length;if(0===b)throw f.NUM;return a=_.sortBy(a),b%2===0?(a[b/2-1]+a[b/2])/2:a[(b-1)/2]}return c.implementNumericAggregationWithArray(a,g)}()},MIN:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:d("min",g)},MINA:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:d("min",h)},MODE:{category:"statistical",altNames:{ooxml:"MODE.SNGL"},minParams:1,type:"val",signature:"any",resolve:function(){function a(a){if(0===a.length)throw f.NA;var b=_.countBy(a),c=_.reduce(b,function(a,b){return Math.max(a,b)},0),d={};if(1===c)throw f.NA;return _.each(b,function(a,b){a===c&&(d[b]=!0)}),_.find(a,function(a){return a in d})}return c.implementNumericAggregationWithArray(a,{valMode:"exact",matMode:"skip",refMode:"exact",emptyParam:!0,complexRef:!1})}()},"MODE.MULT":{category:"statistical",supported:"ooxml",minParams:1,type:"val"},NEGBINOMDIST:{category:"statistical",altNames:{ooxml:"NEGBINOM.DIST"},minParams:3,maxParams:3,type:"val"},NORMDIST:{category:"statistical",altNames:{ooxml:"NORM.DIST"},minParams:4,maxParams:4,type:"val"},NORMINV:{category:"statistical",altNames:{ooxml:"NORM.INV"},minParams:3,maxParams:3,type:"val"},NORMSDIST:{category:"statistical",altNames:{ooxml:"NORM.S.DIST"},minParams:1,maxParams:1,type:"val"},NORMSINV:{category:"statistical",altNames:{ooxml:"NORM.S.INV"},minParams:1,maxParams:1,type:"val"},PEARSON:{category:"statistical",minParams:2,maxParams:2,type:"val"},PERCENTILE:{category:"statistical",altNames:{ooxml:"PERCENTILE.INC"},minParams:2,maxParams:2,type:"val"},"PERCENTILE.EXC":{category:"statistical",supported:"ooxml",minParams:2,maxParams:2,type:"val"},PERCENTRANK:{category:"statistical",altNames:{ooxml:"PERCENTRANK.INC"},minParams:2,maxParams:{ooxml:3,odf:2},type:"val"},"PERCENTRANK.EXC":{category:"statistical",supported:"ooxml",minParams:2,maxParams:3,type:"val"},PERMUT:{category:"statistical",minParams:2,maxParams:2,type:"val"},PERMUTATIONA:{category:"statistical",minParams:2,maxParams:2,type:"val"},PHI:{category:"statistical",minParams:1,maxParams:1,type:"val"},POISSON:{category:"statistical",altNames:{ooxml:"POISSON.DIST"},minParams:3,maxParams:3,type:"val"},PROB:{category:"statistical",minParams:3,maxParams:4,type:"val"},QUARTILE:{category:"statistical",altNames:{ooxml:"QUARTILE.INC"},minParams:2,maxParams:2,type:"val"},"QUARTILE.EXC":{category:"statistical",supported:"ooxml",minParams:2,maxParams:2,type:"val"},RANK:{category:"statistical",altNames:{ooxml:"RANK.EQ"},minParams:2,maxParams:3,type:"val"},"RANK.AVG":{category:"statistical",supported:"ooxml",minParams:2,maxParams:3,type:"val"},RSQ:{category:"statistical",minParams:2,maxParams:2,type:"val"},SKEW:{category:"statistical",minParams:1,type:"val"},"SKEW.P":{category:"statistical",supported:"ooxml",minParams:1,type:"val"},SKEWP:{category:"statistical",supported:"odf",minParams:1,type:"val"},SLOPE:{category:"statistical",minParams:2,maxParams:2,type:"val"},SMALL:{category:"statistical",minParams:2,maxParams:2,type:"val"},STANDARDIZE:{category:"statistical",minParams:3,maxParams:3,type:"val"},STDEV:{category:"statistical",altNames:{ooxml:"STDEV.S"},minParams:1,type:"val",signature:"any",resolve:e("dev",!1,g)},STDEVA:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:e("dev",!1,h)},STDEVP:{category:"statistical",altNames:{ooxml:"STDEV.P"},minParams:1,type:"val",signature:"any",resolve:e("dev",!0,g)},STDEVPA:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:e("dev",!0,h)},STEYX:{category:"statistical",minParams:2,maxParams:2,type:"val"},TDIST:{category:"statistical",minParams:3,maxParams:3,type:"val"},"T.DIST":{category:"statistical",supported:"ooxml",minParams:3,maxParams:3,type:"val"},"T.DIST.2T":{category:"statistical",supported:"ooxml",minParams:2,maxParams:2,type:"val"},"T.DIST.RT":{category:"statistical",supported:"ooxml",minParams:2,maxParams:2,type:"val"},TINV:{category:"statistical",minParams:2,maxParams:2,type:"val"},"T.INV":{category:"statistical",supported:"ooxml",minParams:2,maxParams:2,type:"val"},"T.INV.2T":{category:"statistical",supported:"ooxml",minParams:2,maxParams:2,type:"val"},TREND:{category:"statistical",minParams:1,maxParams:4,type:"mat"},TRIMMEAN:{category:"statistical",minParams:2,maxParams:2,type:"val"},TTEST:{category:"statistical",altNames:{ooxml:"T.TEST"},minParams:4,maxParams:4,type:"val"},VAR:{category:"statistical",altNames:{ooxml:"VAR.S"},minParams:1,type:"val",signature:"any",resolve:e("var",!1,g)},VARA:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:e("var",!1,h)},VARP:{category:"statistical",altNames:{ooxml:"VAR.P"},minParams:1,type:"val",signature:"any",resolve:e("var",!0,g)},VARPA:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:e("var",!0,h)},WEIBULL:{category:"statistical",altNames:{ooxml:"WEIBULL.DIST"},minParams:4,maxParams:4,type:"val"},ZTEST:{category:"statistical",altNames:{ooxml:"Z.TEST"},minParams:3,maxParams:3,type:"val"}}});