define("io.ox/office/spreadsheet/model/formula/tokenizer",["io.ox/office/tk/utils","io.ox/office/tk/locale/localedata","io.ox/office/tk/locale/parser","io.ox/office/baseframework/model/modelobject","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/sheetref","io.ox/office/spreadsheet/model/formula/cellref","io.ox/office/spreadsheet/model/formula/tokens"],function(a,b,c,d,e,f,g,h,i){"use strict";function j(a){return a.toUpperCase()}function k(a,c){this.docModel=a,this.formatter=a.getNumberFormatter(),this.MAXCOL=a.getMaxCol(),this.MAXROW=a.getMaxRow();var d=a.getApp();switch(c){case"op":_.extend(this,{DEC:".",SEP:",",TRUE:"TRUE",FALSE:"FALSE",ERRORS:d.getNativeErrorCodes(),OPERATORS:{eq:"=",ne:"<>",lt:"<",le:"<=",gt:">",ge:">=",con:"&",pct:"%",add:"+",sub:"-",mul:"*",div:"/",pow:"^",list:",",isect:" ",range:":"},MAT_ROW:";",MAT_COL:",",R1C1_R:"R",R1C1_C:"C",getErrorCodeText:_.property("code"),getErrorCodeValue:e.makeErrorCode,getFunctionText:j,getFunctionValue:j});break;case"ui":_.extend(this,{DEC:b.DEC,SEP:d.getListSeparator(),TRUE:d.getBooleanLiteral(!0),FALSE:d.getBooleanLiteral(!1),ERRORS:d.getLocalizedErrorCodes(),OPERATORS:{eq:"=",ne:"<>",lt:"<",le:"<=",gt:">",ge:">=",con:"&",pct:"%",add:"+",sub:"-",mul:"*",div:"/",pow:"^",list:d.getListSeparator(),isect:" ",range:":"},MAT_ROW:"|",MAT_COL:";",R1C1_R:r[0],R1C1_C:r[1],getErrorCodeText:d.convertErrorCodeToString.bind(d),getErrorCodeValue:d.convertStringToErrorCode.bind(d),getFunctionText:d.getLocalizedFunctionName.bind(d),getFunctionValue:d.getNativeFunctionName.bind(d)});break;default:throw new RangeError('Tokenizer.createConfig(): invalid formula grammar "'+c+'"')}this.REF_ERROR=this.getErrorCodeText(n.REF);var g="[a-z_¡-‧‪-￿]",h="[\\w.¡-‧‪-￿]",i="[^\0--\\[\\]'*?:/\\\\]",k="[\\w.\\\\¡-‧‪-￿]",l="[a-z_\\\\¡-‧‪-￿]",m="[\\w.\\\\\\?¡-‧‪-￿]",o=g+h+"*",p=i+"+(?:(?:'')+"+i+"+)*",q="(?:\\[("+k+"+)\\])",s=_.escapeRegExp(this.REF_ERROR),t="(?!\\(|!|"+m+")",u="(?:("+o+")|'("+p+")'|("+s+"))!",v="(?:"+u+")?",w="(?:("+o+"):("+o+")|'("+p+"):("+p+")')!",x="(\\$)?([a-z]+)",y="(\\$)?([0-9]+)",z=x+y,A=z+":"+z,B=x+":"+x,C=y+":"+y,D="("+l+m+"*)",E="([!§$?°~#;,.|])";this.RE={WHITESPACE:/^[\s\x00-\x1f\x80-\x9f]+/,STRING_LIT:/^(".*?")+/,BOOLEAN_LIT:new RegExp("^("+_.escapeRegExp(this.TRUE)+"|"+_.escapeRegExp(this.FALSE)+")(?!"+m+")","i"),ERROR_LIT:new RegExp("^("+_.map(this.ERRORS,_.escapeRegExp).join("|")+")(?!"+m+")","i"),MATRIX_OPEN:/^{/,MATRIX_COL_SEPARATOR:new RegExp("^"+_.escapeRegExp(this.MAT_COL)),MATRIX_ROW_SEPARATOR:new RegExp("^"+_.escapeRegExp(this.MAT_ROW)),MATRIX_CLOSE:/^}/,SEPARATOR:new RegExp("^"+_.escapeRegExp(this.SEP)),OPERATORS:_.map(this.OPERATORS,function(a,b){return{id:b,op:a,re:new RegExp("^"+_.escapeRegExp(a))}}).sort(function(a,b){return b.op.length-a.op.length}),OPEN:/^\(/,CLOSE:/^\)/,CELL_REF:new RegExp("^"+v+z+t,"i"),CELL_CUBE_REF:new RegExp("^"+w+z+t,"i"),CELL_RANGE_REF:new RegExp("^"+v+A+t,"i"),CELL_RANGE_CUBE_REF:new RegExp("^"+w+A+t,"i"),COL_RANGE_REF:new RegExp("^"+v+B+t,"i"),COL_RANGE_CUBE_REF:new RegExp("^"+w+B+t,"i"),ROW_RANGE_REF:new RegExp("^"+v+C+t,"i"),ROW_RANGE_CUBE_REF:new RegExp("^"+w+C+t,"i"),ERROR_REF:new RegExp("^"+u+s,"i"),ERROR_CUBE_REF:new RegExp("^"+w+s,"i"),FUNCTION_REF:new RegExp("^"+v+D+"(?=\\()","i"),SHEET_NAME_REF:new RegExp("^"+u+D+t,"i"),GLOBAL_NAME_REF:new RegExp("^"+D+t,"i"),INVALID_CHAR:new RegExp("^"+E),NAME_COMPLETE:new RegExp("^"+D+"$","i"),UNENCODED_SHEET_NAME_COMPLETE:new RegExp("^"+o+"$","i"),UNENCODED_EXT_SHEET_COMPLETE:new RegExp("^"+q+"?"+o+"(:"+o+")?$","i")},f.info("GrammarConfig(): grammar="+c+" config=",this)}function l(a,b){this.token=a,this.text=b,this.start=0,this.end=0}function m(b,e){var j=k.create(b,e);d.call(this,b),this.getGrammar=function(){return e},this.getConfig=function(){return j},this.validateNameLabel=function(a){function c(c){var d=s(c).exec(a);if(!d)return!1;var e=d[1]?parseInt(d[1],10)-1:0,f=d[2]?parseInt(d[2],10)-1:0;return b.isValidAddress(new o(f,e))}if(0===a.length)return"name:empty";if(!j.RE.NAME_COMPLETE.test(a))return"name:invalid";if(b.getApp().isOOXML()){var d=o.parse(a);if(d&&b.isValidAddress(d))return"name:address";if(c(q)||c(r))return"name:address"}return""},this.encodeExtendedSheetRef=function(a){var b=j.RE.UNENCODED_EXT_SHEET_COMPLETE.test(a);return b?a:"'"+a.replace(/'/g,"''")+"'"},this.parseFormula=function(d,e){function k(a){z.push(new l(a,s[0]))}function m(){!u&&r&&(u=new g(q,!0)),k(new i.ReferenceToken(b,w,x,u,v))}function n(a){!a&&!u&&r&&r.getNameCollection().hasNameModel(y)&&(u=new g(q,!0)),k(new i.NameToken(b,y,u,a))}function o(a){if(s=a.re.exec(d))return k(new i.OperatorToken(a.id)),!0}function p(){var a=_.last(z);a&&a.token.isType("bad")?(a.token.appendValue(s[0]),a.text+=s[0]):k(new i.FixedToken("bad",s[0]))}var q=a.getIntegerOption(e,"extendSheet",-1),r=b.getSheetModel(q),s=null,t=!1,u=null,v=null,w=null,x=null,y=null,z=[];for(f.info('Tokenizer.parseFormula(): formula="'+d+'"');d.length>0;)try{if(s=j.RE.WHITESPACE.exec(d)){k(new i.FixedToken("ws",s[0]));continue}if(!t){if(s=j.RE.MATRIX_OPEN.exec(d)){k(new i.MatrixDelimiterToken("mat_open")),t=!0;continue}if(s=j.RE.SEPARATOR.exec(d)){k(new i.SeparatorToken);continue}if(j.RE.OPERATORS.some(o))continue;if(s=j.RE.OPEN.exec(d)){k(new i.ParenthesisToken(!0));continue}if(s=j.RE.CLOSE.exec(d)){k(new i.ParenthesisToken(!1));continue}if((s=j.RE.CELL_RANGE_CUBE_REF.exec(d))&&(u=g.create(b,s[1],s[3]),v=g.create(b,s[2],s[4]),w=h.create(b,s[5],s[6],s[7],s[8]),x=h.create(b,s[9],s[10],s[11],s[12]),u&&v&&w&&x)){m();continue}if((s=j.RE.CELL_CUBE_REF.exec(d))&&(u=g.create(b,s[1],s[3]),v=g.create(b,s[2],s[4]),w=h.create(b,s[5],s[6],s[7],s[8]),x=null,w)){m();continue}if((s=j.RE.COL_RANGE_CUBE_REF.exec(d))&&(u=g.create(b,s[1],s[3]),v=g.create(b,s[2],s[4]),w=h.create(b,s[5],s[6],!0,0),x=h.create(b,s[7],s[8],!0,j.MAXROW),w&&x)){m();continue}if((s=j.RE.ROW_RANGE_CUBE_REF.exec(d))&&(u=g.create(b,s[1],s[3]),v=g.create(b,s[2],s[4]),w=h.create(b,!0,0,s[5],s[6]),x=h.create(b,!0,j.MAXCOL,s[7],s[8]),w&&x)){m();continue}if(s=j.RE.ERROR_CUBE_REF.exec(d)){u=g.create(b,s[1],s[3]),v=g.create(b,s[2],s[4]),w=x=null,m();continue}if((s=j.RE.CELL_RANGE_REF.exec(d))&&(u=g.create(b,s[1],s[2],s[3]),v=null,w=h.create(b,s[4],s[5],s[6],s[7]),x=h.create(b,s[8],s[9],s[10],s[11]),w&&x)){m();continue}if((s=j.RE.CELL_REF.exec(d))&&(u=g.create(b,s[1],s[2],s[3]),v=null,w=h.create(b,s[4],s[5],s[6],s[7]),x=null,w)){m();continue}if((s=j.RE.COL_RANGE_REF.exec(d))&&(u=g.create(b,s[1],s[2],s[3]),v=null,w=h.create(b,s[4],s[5],!0,0),x=h.create(b,s[6],s[7],!0,j.MAXROW),w&&x)){m();continue}if((s=j.RE.ROW_RANGE_REF.exec(d))&&(u=g.create(b,s[1],s[2],s[3]),v=null,w=h.create(b,!0,0,s[4],s[5]),x=h.create(b,!0,j.MAXCOL,s[6],s[7]),w&&x)){m();continue}if(s=j.RE.ERROR_REF.exec(d)){u=g.create(b,s[1],s[2],s[3]),v=w=x=null,m();continue}if(s=j.RE.SHEET_NAME_REF.exec(d)){u=g.create(b,s[1],s[2],s[3]),y=s[4],n(!1);continue}if(s=j.RE.FUNCTION_REF.exec(d)){u=g.create(b,s[1],s[2],s[3]),y=u?s[4]:j.getFunctionValue(s[4]),n(!0);continue}}if(t){if(s=j.RE.MATRIX_ROW_SEPARATOR.exec(d)){k(new i.MatrixDelimiterToken("mat_row"));continue}if(s=j.RE.MATRIX_COL_SEPARATOR.exec(d)){k(new i.MatrixDelimiterToken("mat_col"));continue}if(s=j.RE.MATRIX_CLOSE.exec(d)){k(new i.MatrixDelimiterToken("mat_close")),t=!1;continue}}if(s=c.parseLeadingNumber(d,{sep:j.DEC,sign:t})){y=s.number,s=[s.text],k(new i.LiteralToken(y));continue}if(s=j.RE.STRING_LIT.exec(d)){y=s[0].slice(1,s[0].length-1).replace(/""/g,'"'),k(new i.LiteralToken(y));continue}if(s=j.RE.BOOLEAN_LIT.exec(d)){y=s[0].toUpperCase()===j.TRUE,k(new i.LiteralToken(y));continue}if(s=j.RE.ERROR_LIT.exec(d)){y=j.getErrorCodeValue(s[0]),k(new i.LiteralToken(y));continue}if(!t&&(s=j.RE.GLOBAL_NAME_REF.exec(d))){u=null,y=s[1],n(!1);continue}if(s=j.RE.INVALID_CHAR.exec(d)){p();continue}s=[d],p()}finally{d=d.slice(s[0].length)}return f.logTokens("  tokenize",z),a.iterateArray(z,function(a,b){var c=a.token,d=z[b-1],e=z[b+1],f=d&&d.token.isType("ws")?z[b-2]:d,g=null;c.isType("op")&&"-"===c.getValue()&&e&&e.token.isType("lit")&&_.isNumber(g=e.token.getValue())&&g>0&&(!f||f.token.matchesType(/^(op|sep|open)$/))&&(a.token=new i.LiteralToken(-g),a.text+=e.text,z.splice(b+1,1));var h=null;if(" "===j.OPERATORS.isect&&c.isType("ws")&&(h=a.text.indexOf(" "))>=0&&d&&d.token.matchesType(/^(ref|name|close)$/)&&e&&e.token.matchesType(/^(ref|name|open|func)$/)){if(h+1<a.text.length){var k=a.text.slice(h+1);z.splice(b+1,0,new l(new i.FixedToken("ws",k),k))}z.splice(b+1,0,new l(new i.OperatorToken("isect")," ")),h>0?(c.setValue(a.text.slice(0,h)),a.text=c.getValue()):z.splice(b,1)}},{reverse:!0,context:this}),f.logTokens("  postprocess",z),z.forEach(function(a,b){a.index=b,a.start=0===b?0:z[b-1].end,a.end=a.start+a.text.length}),z},this.registerDestructor(function(){b=j=null})}var n=e.ErrorCodes,o=e.Address,p=e.Range,q="RC",r=function(){var c={ar:"RC",ca:"FC",cs:"RC",da:"RC",de:"ZS",en:"RC",es:"FC",et:"RC",fi:"RS",fr:"LC",hu:"SO",is:"RC",it:"RC",ja:"RC",ko:"RC",lv:"RK",nl:"RK",nn:"RC",pl:"WK",pt:"LC",ro:"RC",ru:"RC",sk:"RC",sl:"RC",sv:"RC",zh:"RC"};return b.LANGUAGE in c?c[b.LANGUAGE]:(a.warn("Tokenizer: missing R1C1 notation characters, falling back to English"),"RC")}(),s=_.memoize(function(a){return new RegExp("^(?:"+a[0]+"(\\d*))?(?:"+a[1]+"(\\d*))?$","i")});return k.create=function(){function a(a,c){var d=a.getUid();d in b||(b[d]={},a.registerDestructor(function(){delete b[d]}));var e=b[d][c];return e?e:(e=new k(a,c),b[d][c]=e,e)}var b={};return a}(),k.prototype.generateLiteralText=function(c){return _.isNumber(c)?_.isFinite(c)?Math.abs(c)<f.MIN_VALUE?"0":this.formatter.formatStandardNumber(c,e.MAX_LENGTH_STANDARD_EDIT).replace(b.DEC,this.DEC):this.getErrorCodeText(n.NUM):_.isString(c)?'"'+c.replace(/"/g,'""')+'"':_.isBoolean(c)?c?this.TRUE:this.FALSE:e.isErrorCode(c)?this.getErrorCodeText(c):(_.isNull(c)||a.warn("GrammarConfig.generateLiteralText(): unsupported value type"),"")},k.prototype.generateSheetName=function(a,b){if(!a)return"";var c=_.isNumber(a.sheet)?this.docModel.getSheetName(a.sheet):a.sheet;if(!_.isString(c))return this.REF_ERROR+"!";var d=this.RE.UNENCODED_SHEET_NAME_COMPLETE.test(c);if(b&&!a.equals(b)){var e=_.isNumber(b.sheet)?this.docModel.getSheetName(b.sheet):b.sheet;if(!_.isString(e))return this.REF_ERROR+"!";d=d&&this.RE.UNENCODED_SHEET_NAME_COMPLETE.test(e),c+=":"+e}return d?c+"!":"'"+c.replace(/'/g,"''")+"'!"},k.prototype.generateReference=function(a,b,c,d){var e=a?p.createFromAddresses(a.address,b&&b.address):null,f=this.generateSheetName(c,d);return e?a.absCol&&b&&b.absCol&&this.docModel.isRowRange(e)?f+=a.rowText()+":"+b.rowText():a.absRow&&b&&b.absRow&&this.docModel.isColRange(e)?f+=a.colText()+":"+b.colText():(f+=a.refText(),b&&(f+=":"+b.refText())):f+=this.REF_ERROR,f},l.prototype.toString=function(){return this.token.toString()},d.extend({constructor:m})});